;
;   Random BMP Put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     0x0 , 0x0         ; I_Param , I_Icon

;******************************************************************************
;5941 ;4523(with new random)



include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    mov [canvas_x],640
    mov [canvas_y],480

    call draw_window

    loadbmp '/RD/1/MFAR.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img
    loadbmp '/RD/1/SMILE.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img2
    loadbmp '/RD/1/COPY.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img3

;    fullimg canvas , 32 ,32 ,0x00ff0000   ;black

still:



    mov  eax,11                 ; scan event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button

del_images:


;    setimg dword [ply2x],dword [ply2y],img4
;    setimg dword [ballx],dword [bally],img4



move_images:

x_move:
    mov eax,dword [ply1rx]
    cmp dword [ply1x],eax
    je  no_m
    cmp dword [ply1x],eax
    jg  m_m
m_p:
    add dword [ply1x],1;2
    jmp no_m
m_m:
    sub dword [ply1x],1;2
no_m:


y_move:
    mov eax,dword [ply1ry]
    cmp dword [ply1y],eax
    je  no_m2
    cmp dword [ply1y],eax
    jg  m_m2
m_p2:
    add dword [ply1y],1;2
    jmp no_m2
m_m2:
    sub dword [ply1y],1;2
no_m2:

;    mov [canvas+8],dword 0x00ffffff



; put img
; edi xcor
; esi ycor

    mov ebx,10 ;10x
    mov ecx,10 ;10y

    mov edi,[ply1x] ;edi
    mov esi,[ply1y]

looy:
    push ebx
loox:
pushad
    mov ebx,img
    mov ecx,canvas
    call put_img
popad
    add edi,32
    dec ebx
    jns loox
pop ebx
    mov edi,[ply1x]
    add esi,32
    dec ecx
    jns looy

draw_canvas:


    setimg 5,21,canvas

;    delay 2             ;don't generate delay for fast speed programm

    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    mov eax,2
    int 0x40
    cmp ah,key_Left
    jne no_l
    sub dword [ply1rx],16
no_l:
    cmp ah,key_Right
    jne no_r
    add dword [ply1rx],16
no_r:
    cmp ah,key_Up
    jne no_u
    sub dword [ply1ry],16
no_u:
    cmp ah,key_Down
    jne no_d
    add dword [ply1ry],16
no_d:

    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

;ebx img
;ecx canvas

put_img:
;getout coord
    cmp edi,[ecx]
    ja  noout
    cmp esi,[ecx+4]
    ja  noout

;    push edi

    mov eax,esi ;y cor
    mul dword [ecx] ;canvas xsize
    add eax,edi ;x cor
    mov ebp,eax
    shl eax,1
    add ebp,eax
    add ebp,ecx ;canvas+8;start
    add ebp,8
;get img size
    mov eax,ebx ;img   ;xsize
    mov esi,[eax]
    add eax,4
;    mov eax,ebx ; img+4 ;ysize
    mov edi,[eax]
    add eax,4
    mov edx,eax ;img+8

;    pop eax ;edi
;    mov eax,edi
;    add eax,[ebx] ;imgx+sizex
;    cmp edi,[ecx] ;cmp xcor,xcnvsize
;    jna xok
;    sub eax,[ebx]
;    sub
;xok:


loo2:
push esi
loo:
    mov al,byte [edx]
    mov byte [ebp],al
    inc ebp
    inc edx
    mov al,byte [edx]
    mov byte [ebp],al
    inc ebp
    inc edx
    mov al,byte [edx]
    mov byte [ebp],al
    inc ebp
    inc edx
    dec esi
    jns loo
pop esi
    sub edx,3
    sub ebp,3
    mov eax,[ecx]  ;offset = offset+((canxsize-imgxsize)*3)
    sub eax,esi
    add ebp,eax
    shl eax,1
    add ebp,eax
    dec edi
    jns loo2
noout:
    ret

draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'2D EXAMPLE: MOVE ICON: USE ARROW KEYS',cl_White+font_Big
;    call load_image
    endwd
    ret


; DATA AREA
xt dd 100
yt dd 100

ply1rx dd 200
ply1ry dd 50


ply1x dd 200
ply1y dd 50

ply2x dd 200
ply2y dd 400

ballx dd 200
bally dd 200

counter dd 0
tsoi dd 0
tsoi2 dd 0
tsoi3 dd 0

IM_END:

matrix:
    db '0123456789012345678901234567890123456789'
    db '0121      012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0121      012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0121      01234567890123456       456789'
    db '0123456789012345678901234567890123456789'
    db '01234567890123456789012       0123456789'
    db '012345678901234567890      7890123456789'
    db '0121      012345678901234567890123456789'

img:
rd 32*32*3+8
img2:
rb 32*32*3+8
img3:
rb 32*32*3+8
;img4:
;rb 32*32*3+8
;img5:
;rb 32*32*3+8

temp_area:
rb 0x15000

canvas:
canvas_x rd 1
canvas_y rd 1
;rb (640*480*3)


I_END = canvas+(640*480*3)+8
