;
;   Phenix Dynamic Game Created by Pavlushin Evgeni for ASCL
;
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'


macro readmas masoff,obroff
{
local loo
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    call obroff
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
}


macro compmas masoff1,masoff2,obroff
{
local loo,loo2
    mov esi,masoff2
    add esi,8
    mov ecx,[masoff2]
    mov ebx,[masoff2+4]
    mov eax,0

loo2:
    push eax

    mov edi,masoff1   ;tekoff
    add edi,8
    mov ebp,[masoff1]   ;elements1
    mov edx,[masoff1+4] ;elemsize1
    mov eax,0 ;count
loo:
    pushad
    call obroff
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo

    add  esi,ebx
    pop  eax
    inc  eax
    cmp  eax,ecx
    jne  loo2
}


macro findmas masoff,obroff
{
local loo,looend,lend
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    mov  eax,0
    call obroff
    cmp  eax,1
    je   looend
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
    stc
    jmp  lend
looend:
    popad
    clc
lend:
}


randmas:
    push edi
    random 200,eax
    pop edi
    mov [edi],eax
    push edi
    random 200,eax
    pop edi
    mov [edi+4],eax
;    push edi
;    random 2,eax
;    pop edi
;    mov [edi+8],eax
    ret

randobjmas:
    push edi
    random 600,eax
    pop edi
    mov [edi],eax
    push edi
    random 40000,eax
    neg eax
    pop edi
    mov [edi+4],eax
    push edi
    random 3,eax
    inc eax
    pop edi
    mov [edi+8],eax
    push edi
    random 7,eax
    sub eax,3
    pop edi
    mov [edi+12],eax
    push edi
    random 5,eax
    sub eax,2
    pop edi
    mov [edi+16],eax
    ret


showmas:
    cmp [edi+8],dword 0
    je  noshow
;    setimg [edi],[edi+4],shoot
    cmp [edi+8],dword 1
    jne no_gun
    mov eax,shoot
    jmp outp
no_gun:
    push edi
    random 3,ebx
    pop edi
    cmp ebx,0
    jne no_star
    mov eax,star
    jmp outp
no_star:
    cmp ebx,1
    jne no_star2
    mov eax,star2
    jmp outp
no_star2:
    mov eax,star3
outp:
    aimgtoimg eax,dword [edi],dword [edi+4],canvas,0x0
noshow:
    ret

showobjmas:
    cmp [edi+8],dword 0
    je  noshow1
    cmp [edi+4],dword 380
    jg  noshow1
    cmp [edi+4],dword 0
    jl  noshow1
;    setimg [edi],[edi+4],shoot
    cmp [edi+8],dword 1
    jne no_warship1
    mov eax,warship1
    jmp outws
no_warship1:
    cmp [edi+8],dword 2
    jne no_warship2
    mov eax,warship2
    jmp outws
no_warship2:
    mov eax,meteor
outws:
    aimgtoimg eax,dword [edi],dword [edi+4],canvas,0x0
noshow1:
    ret


moveobjmas:
    cmp [edi+8],dword 0
    je  no_ws
;    add dword [edi+4],5
    mov eax,[edi+12]
    add [edi],eax
    mov eax,[edi+16]
    add [edi+4],eax

    cmp dword [edi],600
    jng xok1
    sub dword [edi],20
    neg dword [edi+12]
    jmp xok2
xok1:
    cmp dword [edi],0
    jnl xok2
    add dword [edi],20
    neg dword [edi+12]
xok2:

    cmp dword [edi+8],2  ;green ship
    jne no_grs
    cmp dword [edi+4],100
    jna no_grs
    cmp dword [edi+4],102
    jna grs
    cmp dword [edi+4],200
    jna no_grs
    cmp dword [edi+4],202
    jna  grs
    cmp dword [edi+4],300
    jna no_grs
    cmp dword [edi+4],302
    ja  no_grs
grs:
    neg dword [edi+12]
no_grs:

no_ws:
    ret


delfarshoot:
    cmp [edi+4],dword 20
    ja  nodel
    mov [edi+8],dword 0
nodel:
    ret


movemas:
    cmp [edi+8],dword 1
    jne no_gunp
    cmp [edi+8],dword 0
    je  no_starp
    sub dword [edi+4],15
no_starp:
    ret
no_gunp:
    sub dword [edi+4],5
    mov eax,[edi+12]
    add [edi],eax
    mov eax,[edi+16]
    add [edi+4],eax
    ret

findzero:
    cmp [edi+8],dword 0
    je  iz_zero
    xor eax,eax
    ret
iz_zero:
    mov eax,1
    ret

compobr:
    cmp [esi+8],dword 0
    je  no_crsh
    cmp [edi+8],dword 0
    je  no_crsh

    mov eax,[esi]
    mov [temp],eax
    mov eax,[esi+4]
    mov [temp2],eax
    mov eax,[edi]
    mov [temp3],eax
    mov eax,[edi+4]
    mov [temp4],eax

    pushad
    collimg imgsize,[temp],[temp2],imgsize,[temp3],[temp4],[otv]
    popad
    cmp [otv],dword 0
    je  no_crsh

    cmp [edi+8],dword 2
    jne no_grship
    inc [gship]
    jmp setzero
no_grship:
    cmp [edi+8],dword 1
    jne no_blship
    inc [bship]
    jmp setzero
no_blship:

setzero:
    mov [esi+8],dword 0
    mov [edi+8],dword 0
no_crsh:
    ret


START:                          ; start of execution

massize = 400
elemsize = 20

    mov [massive],dword massize
    mov [massive+4],dword elemsize

omassize = 100
oelemsize = 20

    mov [objmas],dword omassize
    mov [objmas+4],dword oelemsize


    mov eax,66
    mov ebx,1
    mov ecx,1
    int 0x40

    mov eax,26
    mov ebx,2
    mov ecx,1
    mov edx,keymap
    int 0x40

startgame:
    gif_hash_offset = gif_hash_area
    giftoimg gif_file_area2,canvas

;step1 define offset of hash area for unpacking gif file
;      size 16384+4 bytes
    gif_hash_offset = gif_hash_area
;step2 converting gif format to img format for easy out to screen
;      gif_file_area - offset of gif load file
;      img_area      - offset of img image
    giftoimg gif_file_area,img_area
;step3 out image from img_area
    getimg img_area,0,0,32,32,ship
    getimg img_area,32,0,32,32,shoot
    getimg img_area,64,0,32,32,warship1
    getimg img_area,96,0,32,32,warship2
    getimg img_area,128,0,32,32,meteor
    getimg img_area,160,0,32,32,star
    getimg img_area,192,0,32,32,star2
    getimg img_area,224,0,32,32,star3



main_menu:
    call draw_logowindow

stillm:
    wtevent redm,keym,buttonm
;    setimg 5,21,canvas
    jmp stillm
redm:
    call draw_logowindow
;    setimg 5,21,canvas
    jmp stillm
keym:
    mov  eax,2
    int  0x40
    jmp  stillm
buttonm:
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    je   close_app
    cmp  ah,2                   ; button id=1 ?
    je   start_game
    cmp  ah,3                   ; button id=1 ?
    je   help
    cmp  ah,4                   ; button id=1 ?
    je   close_app
    jmp  stillm

draw_logowindow:
    call draw_window
    setimg 5,21,canvas
    drawlbut 300,300,60,14,'START',2,0x990000,cl_Black
    drawlbut 300,320,60,14,'HELP',3,0x990000,cl_Black
    drawlbut 300,340,60,14,'EXIT',4,0x990000,cl_Black
    ret

help:
    call draw_helpwindow

stillh:
    wtevent redh,keyh,buttonh
;    setimg 5,21,canvas
    jmp stillh
redh:
    call draw_helpwindow
;    setimg 5,21,canvas
    jmp stillh
keyh:
    mov  eax,2
    int  0x40
    jmp  stillh
buttonh:
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    je   close_app
    cmp  ah,2                   ; button id=1 ?
    je   start_game
    cmp  ah,3                   ; button id=1 ?
    je   help
    cmp  ah,4                   ; button id=1 ?
    je   close_app
    cmp  ah,5                   ; button id=1 ?
    je   main_menu
    jmp  stillh

draw_helpwindow:
    call draw_window
    setimg 5,21,canvas

    drawfbox 40,50,580,380,cl_Grey

    mov ebp,4*6
    mov ebx,180*65536+90
    mov edx,helptext
    mov esi,50
    mov ecx,cl_White
    dec ebp
looht:
    mov eax,4
    int 0x40
    add edx,esi
    add ebx,10
    dec ebp
    jnz looht

    setimg 90,90,ship
    setimg 90,130,shoot
    setimg 90,170,star
    setimg 90,210,warship1
    setimg 90,250,warship2
    setimg 90,290,meteor

    drawlbut 500,400,80,14,'<<BACK',5,0x990000,cl_Black

    jmp stillh

helptext:
    db 'Phenix                                            '
    db 'Controls: Num1 move left, Num3 move right         '
    db '                                                  '
    db '                                                  '

    db 'Lazer cannon                                      '
    db 'Press Num5 for shoot                              '
    db 'Core fast, speed fast, reload slow                '
    db '                                                  '

    db 'Plazma cannon                                     '
    db 'Press Num2 for Plazma Nuke and Num8 for shoot     '
    db 'Core slow, speed medium, reload fast              '
    db '                                                  '

    db 'Blue warship                                      '
    db '                                                  '
    db '                                                  '
    db '                                                  '

    db 'Green warship                                     '
    db '                                                  '
    db '                                                  '
    db '                                                  '

    db 'Meteor                                            '
    db '                                                  '
    db '                                                  '
    db '                                                  '

start_game:
    mov [canvas],dword 640
    mov [canvas+4],dword 440

    readmas massive,randmas

;random warships

;    readmas objmas,randobjmas

    call draw_window

;Main loop wait for event with 10msec
still:
;    scevent red,key,button ;for full speed

    timeevent 1,no_event,red,key,button
no_event:
    setimg 5,21,canvas

    cmp [ctime],dword 0
    je  no_dct
    dec dword [ctime]
no_dct:

    cmp [xtime],dword 0
    je  no_dxt
    dec dword [xtime]
no_dxt:


;
;   Add to level new ships
;
    inc dword [pathtime]
    mov ebp,[levelpart]
    shl ebp,5
    add ebp,levels
    mov eax,[ebp]
;    cmp [ebp+4],dword 0
;    je  main_menu    ;end of game
    cmp [pathtime],eax ;500
    jne no_nextloc
;    readmas objmas,randobjmasx

    findmas objmas,findzero
;in edi off to free element
    jc  close_app
    call randobjmasx
    jmp newlocend
randobjmasx:
    push eax  ;in eax element num
    push edi
    random 600,eax
    pop edi
    mov [edi],eax
    push edi
    mov ebp,[levelpart]
    shl ebp,5
    add ebp,levels
    mov esi,[ebp+4]
    random esi,eax
    neg eax
    pop edi
    mov [edi+4],eax
    push edi
    random 2,eax
    inc eax
    pop edi
    push edi
    random 3,eax
    sub eax,1
    pop edi
    mov [edi+12],eax
    push edi
    random 3,eax
    add eax,4
    pop edi
    mov [edi+16],eax

    pop eax
    mov ebp,[levelpart]
    shl ebp,5
    add ebp,levels
    mov ebx,omassize
    sub ebx,[ebp+8]
    cmp eax,ebx  ;16

    jmp add_shipgr

    jae  add_shipgr
    sub ebx,[ebp+12]
    cmp eax,ebx;12
    jae  add_shipbl
    sub ebx,[ebp+16]
    cmp eax,ebx;10
    jae  add_met
    mov dword [edi+8],0 ;clear
    ret

levelpart dd 0
levels:
;level1
;    dd 500,16,12,10,0,0,0,0
;    dd 240,100,4,12,0,0,0,0
;    dd 100,1,0,0,2,0,0,0
    dd 100,4000,0,80,0,0,0,0
    dd 800,200,4,12,0,0,0,0
    dd 240,0,0,0,0,0,0,0        ;end of level delay

add_met:
    mov dword [edi+8],3 ;meteor
    ret

add_shipgr:
    mov dword [edi+8],2 ;green ship
    push edi         ;planers
    random 9,eax
    sub eax,4
    pop edi
    mov [edi+12],eax
    push edi
    random 3,eax     ;slow
    add eax,2
    pop edi
    mov [edi+16],eax
    ret
add_shipbl:
    mov dword [edi+8],1 ;blue ship
    push edi         ;fixed
    random 3,eax
    sub eax,1
    pop edi
    mov [edi+12],eax
    push edi
    random 3,eax     ;speed
    add eax,6
    pop edi
    mov [edi+16],eax
    ret
newlocend:
    mov [pathtime],0
    mov ebp,[levelpart]
    shl ebp,5
    add ebp,levels
    mov eax,[ebp+4]
    cmp eax,dword 0
    je  end_gm    ;end of game
    inc [levelpart]
    jmp no_nextloc

end_gm:


    drawfbox 40,50,580,380,cl_Grey
;    drawlbut 500,400,80,14,'<<BACK',5,0x990000,cl_Black

    setimg 90,90,ship
    delay  80

    setimg 90,130,shoot
    delay  80

    setimg 90,170,star
loospg:
    drawfbox 200,170,6*5+2 ,9,cl_Grey
    outcount [plazma],201,171,cl_Blue,5*65536
    delay 1
;    dec  [plazma]
;    jnz  loospg
    sub  [plazma],31
    cmp  [plazma],0
    jnl  loospg


    setimg 90,210,warship1
loosgs:
    drawfbox 200,230,6*5+2 ,9,cl_Grey
    outcount [bship],201,231,cl_Blue,5*65536
    delay 1
    dec  [bship]
    jnz  loosgs


    setimg 90,250,warship2
loosbs:
    drawfbox 200,270,6*5+2 ,9,cl_Grey
    outcount [gship],201,271,cl_Blue,5*65536
    delay 1
    dec  [gship]
    jnz  loosbs

    setimg 90,290,meteor

    delay  600
    close

no_nextloc:

    cmp [num5],dword 0
    je  no_addsh
    cmp [ctime],dword 0
    jne no_addsh
    cmp [lazer],dword 0
    je  no_addsh
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    mov eax,[shipx]
    mov [edi],eax
    mov eax,[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 1   ;show
    mov [ctime],dword 8   ;wait for cannon
    dec [lazer]
no_addsh:

    cmp [num8],dword 0
    je  no_addplx
    cmp [xtime],dword 256-16
    jae no_addplx
    cmp [plazma],0
    je  no_addplx
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    mov eax,[shipx]
    mov [edi],eax
    mov eax,[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 2   ;show
    add [xtime],dword 8  ;wait for cannon
    cmp [xtime],dword 256
    jna okx
    mov [xtime],256
okx:
    mov [edi+12],dword 0  ;wait for cannon
    mov [edi+16],dword -8  ;wait for cannon
    dec [plazma]
no_addplx:



    cmp [num2],dword 0
    je  no_addsh2
    cmp [xtime],dword 0
    jne no_addsh2
    cmp [plazma],0
    je  no_addsh2
    mov eax,[shipy]
    mov [temp3],eax
    mov [temp2],dword 5
loox2:
    mov [temp],dword 10
loox:
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    random 25,eax
    mov ebp,eax
    sub eax,12
    add eax,[shipx]
    mov [edi],eax
    shr ebp,3
    random ebp,eax
    neg eax
    add eax,[temp3] ;[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 2   ;show hstar
    random 5,eax
    sub eax,2
    mov [edi+12],eax   ;show hstar
    random 7,eax
    sub eax,3
    mov [edi+16],eax   ;show hstar
    dec [temp]
    jnz loox
    sub [temp3],30
    dec [temp2]
    jnz loox2
    mov [xtime],dword 256  ;wait for cannon
    sub [plazma],50
no_addsh2:


    cmp [num1],dword 0
    je  no_left
    sub dword [shipx],5
no_left:

    cmp [num3],dword 0
    je  no_right
    add dword [shipx],5
no_right:

;clear scrbuf
    mov edi,canvas+8
    cld
    mov ecx,640*440*3/4
    mov eax,0
    rep stosd

    compmas objmas,massive,compobr

    readmas objmas,showobjmas
    readmas objmas,moveobjmas

    readmas massive,showmas
    readmas massive,movemas
    readmas massive,delfarshoot
    findmas massive,findzero
;in edi off to free element
    jc  close_app
;    mov [edi+8],dword 2
;no_write:

;    setimg [shipx],[shipy],ship
    aimgtoimg ship,[shipx],[shipy],canvas,0x0

    drawfbox 150,5,64,5,0x000000
    mov eax,[xtime]
    sub eax,256
    neg eax
    shr eax,2
    drawfbox 150,5,eax,5,0x0000ff

    drawfbox 150,12,64,5,0x000000
    mov eax,[ctime]
    sub eax,8
    neg eax
    shl eax,3
    drawfbox 150,12,eax,5,0xffff00

;    drawfbox 220,12,64,5,0x000000
;    mov eax,[pathtime]
;    shr eax,7
;    drawfbox 220,12,eax,5,0xffff00

    drawfbox 220,2,6*5+2 ,9,cl_Grey
    outcount [plazma],221,3,cl_Blue,5*65536
    drawfbox 220,11,6*5+2 ,9,cl_Grey
    outcount [lazer],221,12,0xffff00,5*65536


    drawfbox 320,2,6*5+2 ,9,cl_Grey
    outcount [gship],321,3,cl_Blue,5*65536
    drawfbox 320,11,6*5+2 ,9,cl_Grey
    outcount [bship],321,12,0xffff00,5*65536

    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    mov  eax,2
    int  0x40                   ; read (eax=2)

    shr eax,8
    and eax,0xff
    mov ah,al

    cmp ah,76
    jne no_num5d
    mov [num5],1
    jmp still
no_num5d:
    cmp ah,204
    jne no_num5u
    mov [num5],0
    jmp still
no_num5u:

    cmp ah,80
    jne no_num2d
    mov [num2],1
    jmp still
no_num2d:
    cmp ah,208
    jne no_num2u
    mov [num2],0
    jmp still
no_num2u:

    cmp ah,79 ;key_Space 85 exit
    jne no_num1d
    mov [num1],1
    jmp still
no_num1d:
    cmp ah,207 ;key_Space 85 exit
    jne no_num1u
    mov [num1],0
    jmp still
no_num1u:

    cmp ah,81 ;key_Space 85 exit
    jne no_num3d
    mov [num3],1
    jmp still
no_num3d:
    cmp ah,209 ;key_Space 85 exit
    jne no_num3u
    mov [num3],0
    jmp still
no_num3u:

    cmp ah,72  ;key_Space 85 exit
    jne no_num8d
    mov [num8],1
    jmp still
no_num8d:
    cmp ah,200 ;key_Space 85 exit
    jne no_num8u
    mov [num8],0
    jmp still
no_num8u:

    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
close_app:
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window 40,40,(640+9),(440+26),window_Skinned+0x00ffffff
    label  8,8,'ASCL DYNAMIC GAME',cl_White+font_Big
;    setimg 5,22,img_area
    endwd
    ret

; DATA AREA
IM_END:
;massive
shipx dd 300
shipy dd 400

;guns
lazer  dd 10000
plazma dd 8000

;keys
num1 dd 0
num5 dd 0
num3 dd 0
num2 dd 0
num8 dd 0

;enemy countres
gship dd 0
bship dd 0

;delay for cannon
ctime dd 0
;delay for nuke gun
xtime dd 0
;path time
pathtime dd 0
;
temp  dd 0
temp2 dd 0
temp3 dd 0
temp4 dd 0
otv dd 0

;for collimg
imgsize:
 dd 32
 dd 32

;massive:
;dd 400  ;elements num
;dd 20  ;size of element in bytes
;rb 400*20


keymap:
rb 1000

;gif_file_area ~21500
gif_file_area2:
file 'phenix.gif'
rb 50
gif_file_area:
file 'star2.gif';include gif file
rb 50          ;50 bytes temp back zone
img_area:
rb 256*64*3+8
ship:
rb 32*32*3+8
shoot:
rb 32*32*3+8
warship1:
rb 32*32*3+8
warship2:
rb 32*32*3+8
meteor:
rb 32*32*3+8
star:
rb 32*32*3+8
star2:
rb 32*32*3+8
star3:
rb 32*32*3+8
gif_hash_area:
rd 4096+1      ;hash area size for unpacking GIF

massive:
rd massize  ;elements num
rd elemsize  ;size of element in bytes
rb massize*elemsize

objmas:
rd omassize  ;elements num
rd oelemsize  ;size of element in bytes
rb omassize*oelemsize


canvas:
canvas_x:
 rd 1
canvas_y:
 rd 1
rb (640*440*3)+2000
I_END:
